/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package javabahia;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

/**
 *Essa classe tem como objetivo demonstrar a utilizacao do Automatic Resource Management, 
 * em que agora a jvm pode gerenciar tais recursos
 * @author otavio
 */
public class ExemploARM {

    /**
     * metodo com o objetivo de copiar as informacoes de um arquivo para o 
     * outro
     * @param original arquivo com o conteudo a ser copiado
     * @param copiado arquivo que receberao os valores 
     * @throws FileNotFoundException
     * @throws IOException 
     */
    public void copiarArquivo(File original, File copiado) throws FileNotFoundException, IOException {
        try (InputStream in = new FileInputStream(original);
                OutputStream out = new FileOutputStream(copiado)) {
            byte[] buf = new byte[1024];
            int n;
            while ((n = in.read(buf)) >= 0) {
                out.write(buf, 0, n);
            }
        }//sera fechado automaticamente apos operacao
    }
}
